package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[DataAudit] 数据对象
 */
@TableName(value = "T_SRFDATAAUDIT",resultMap = "DataAuditResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class DataAudit extends EntityBase implements Serializable{

    private String auditinfo;
    @Dict(dictName = "ionicdemo_AuditDEActionCodeList")
    private String audittype;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @TableId(value= "dataauditid",type=IdType.UUID)//指定主键生成策略
    private String dataauditid;
    private String dataauditname;
    private String ipaddress;
    private String objectid;
    private String objecttype;
    private String oppersonid;
    private String oppersonname;
    private String sessionid;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[审计明细]
     *  @param auditinfo
     */
    public void setAuditinfo(String auditinfo){
        if(StringUtils.isEmpty(auditinfo))
            auditinfo=null;
        this.auditinfo = auditinfo;
        this.set("auditinfodirtyflag",true);
    }
    /**
     *  获取属性值[审计明细]
     */
    public String getAuditinfo(){
        return this.auditinfo;
    }
    /**
     *  重置属性值[审计明细]
     */
    public void resetAuditinfo(){
        this.set("auditinfodirtyflag",false);
        this.auditinfo = null;
    }
    /**
     *  设置属性值[行为类型]
     *  @param audittype
     */
    public void setAudittype(String audittype){
        if(StringUtils.isEmpty(audittype))
            audittype=null;
        this.audittype = audittype;
        this.set("audittypedirtyflag",true);
    }
    /**
     *  获取属性值[行为类型]
     */
    public String getAudittype(){
        return this.audittype;
    }
    /**
     *  重置属性值[行为类型]
     */
    public void resetAudittype(){
        this.set("audittypedirtyflag",false);
        this.audittype = null;
    }
    /**
     *  设置属性值[操作时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[操作时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[操作时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[数据审计标识]
     *  @param dataauditid
     */
    public void setDataauditid(String dataauditid){
        if(StringUtils.isEmpty(dataauditid))
            dataauditid=null;
        this.dataauditid = dataauditid;
        this.set("dataauditiddirtyflag",true);
    }
    /**
     *  获取属性值[数据审计标识]
     */
    public String getDataauditid(){
        return this.dataauditid;
    }
    /**
     *  重置属性值[数据审计标识]
     */
    public void resetDataauditid(){
        this.set("dataauditiddirtyflag",false);
        this.dataauditid = null;
    }
    /**
     *  设置属性值[审计条目]
     *  @param dataauditname
     */
    public void setDataauditname(String dataauditname){
        if(StringUtils.isEmpty(dataauditname))
            dataauditname=null;
        this.dataauditname = dataauditname;
        this.set("dataauditnamedirtyflag",true);
    }
    /**
     *  获取属性值[审计条目]
     */
    public String getDataauditname(){
        return this.dataauditname;
    }
    /**
     *  重置属性值[审计条目]
     */
    public void resetDataauditname(){
        this.set("dataauditnamedirtyflag",false);
        this.dataauditname = null;
    }
    /**
     *  设置属性值[访问地址]
     *  @param ipaddress
     */
    public void setIpaddress(String ipaddress){
        if(StringUtils.isEmpty(ipaddress))
            ipaddress=null;
        this.ipaddress = ipaddress;
        this.set("ipaddressdirtyflag",true);
    }
    /**
     *  获取属性值[访问地址]
     */
    public String getIpaddress(){
        return this.ipaddress;
    }
    /**
     *  重置属性值[访问地址]
     */
    public void resetIpaddress(){
        this.set("ipaddressdirtyflag",false);
        this.ipaddress = null;
    }
    /**
     *  设置属性值[对象编号]
     *  @param objectid
     */
    public void setObjectid(String objectid){
        if(StringUtils.isEmpty(objectid))
            objectid=null;
        this.objectid = objectid;
        this.set("objectiddirtyflag",true);
    }
    /**
     *  获取属性值[对象编号]
     */
    public String getObjectid(){
        return this.objectid;
    }
    /**
     *  重置属性值[对象编号]
     */
    public void resetObjectid(){
        this.set("objectiddirtyflag",false);
        this.objectid = null;
    }
    /**
     *  设置属性值[对象类型]
     *  @param objecttype
     */
    public void setObjecttype(String objecttype){
        if(StringUtils.isEmpty(objecttype))
            objecttype=null;
        this.objecttype = objecttype;
        this.set("objecttypedirtyflag",true);
    }
    /**
     *  获取属性值[对象类型]
     */
    public String getObjecttype(){
        return this.objecttype;
    }
    /**
     *  重置属性值[对象类型]
     */
    public void resetObjecttype(){
        this.set("objecttypedirtyflag",false);
        this.objecttype = null;
    }
    /**
     *  设置属性值[操作人]
     *  @param oppersonid
     */
    public void setOppersonid(String oppersonid){
        if(StringUtils.isEmpty(oppersonid))
            oppersonid=null;
        this.oppersonid = oppersonid;
        this.set("oppersoniddirtyflag",true);
    }
    /**
     *  获取属性值[操作人]
     */
    public String getOppersonid(){
        return this.oppersonid;
    }
    /**
     *  重置属性值[操作人]
     */
    public void resetOppersonid(){
        this.set("oppersoniddirtyflag",false);
        this.oppersonid = null;
    }
    /**
     *  设置属性值[操作人]
     *  @param oppersonname
     */
    public void setOppersonname(String oppersonname){
        if(StringUtils.isEmpty(oppersonname))
            oppersonname=null;
        this.oppersonname = oppersonname;
        this.set("oppersonnamedirtyflag",true);
    }
    /**
     *  获取属性值[操作人]
     */
    public String getOppersonname(){
        return this.oppersonname;
    }
    /**
     *  重置属性值[操作人]
     */
    public void resetOppersonname(){
        this.set("oppersonnamedirtyflag",false);
        this.oppersonname = null;
    }
    /**
     *  设置属性值[访问标识]
     *  @param sessionid
     */
    public void setSessionid(String sessionid){
        if(StringUtils.isEmpty(sessionid))
            sessionid=null;
        this.sessionid = sessionid;
        this.set("sessioniddirtyflag",true);
    }
    /**
     *  获取属性值[访问标识]
     */
    public String getSessionid(){
        return this.sessionid;
    }
    /**
     *  重置属性值[访问标识]
     */
    public void resetSessionid(){
        this.set("sessioniddirtyflag",false);
        this.sessionid = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetAuditinfo();
        resetAudittype();
        resetCreatedate();
        resetCreateman();
        resetDataauditid();
        resetDataauditname();
        resetIpaddress();
        resetObjectid();
        resetObjecttype();
        resetOppersonid();
        resetOppersonname();
        resetSessionid();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public DataAudit copyTo(DataAudit targetEntity)
	{
		BeanCopier copier=BeanCopier.create(DataAudit.class, DataAudit.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetDataauditid();
		return targetEntity;
	}
}